package org.dromara.mall.trade.service;

import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.mall.trade.domain.bo.MallAddressBo;
import org.dromara.mall.trade.domain.vo.MallAddressVo;

import java.util.Collection;
import java.util.List;

/**
 * 收货地址Service接口
 *
 * @author pengles
 */
public interface MallAddressService {

    /**
     * 查询收货地址
     */
    MallAddressVo queryById(Long id);

    /**
     * 查询收货地址列表
     */
    TableDataInfo<MallAddressVo> queryPageList(MallAddressBo bo, PageQuery pageQuery);

    /**
     * 查询收货地址列表
     */
    List<MallAddressVo> queryList(MallAddressBo bo);

    /**
     * 查询用户的收货地址列表
     */
    List<MallAddressVo> queryListByUserId(Long userId);

    /**
     * 查询用户的默认地址
     */
    MallAddressVo queryDefaultByUserId(Long userId);

    /**
     * 新增收货地址
     */
    Boolean insertByBo(MallAddressBo bo);

    /**
     * 修改收货地址
     */
    Boolean updateByBo(MallAddressBo bo);

    /**
     * 校验并批量删除收货地址信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 设置默认地址
     */
    Boolean setDefault(Long id);

}
